# EDP Documentation

## How to access the Documentation

The EDP documentation is subject to this repo in folder [`docs`](./docs/). It is created in the [`mkdocs`](https://www.mkdocs.org/) documentation format and natively embedded in the [`Backstage TechDocs` documentation technology](https://backstage.io/docs/features/techdocs/).

Thus it can be read in four ways:

### Doc in Backstage in a running Demo EDP

The documentation can be easily accessed through a Demo EDP instance hosted on our Open Sovereign Cloud (OSC).

Thus there you have a Backstage-Developer Portal running, containing the EDP documentation.

Simply log in to [Demo EDP Backstage](https://forgejo.edf-bootstrap.cx.fg1.ffm.osc.live/DevFW-CICD/stacks) to read through the documentation.

* [EDP Documentation URL](https://edf-cc1.cx.fg1.ffm.osc.live/docs/edppoc/component/edp-documentation)
* Username: user1
* Password: PpMpfZYICG9MRRF-3QBY2Zz1-+URYB6+-JRe

### Doc in Backstage in a Demo EDP setup on your computer

As `edpbuilder` is a infrastructure agnostic platform orchestrator, you also can boostrap the EDP Demo on your own laptop!

Using the edpbuilder, you can set up a local Demo EDP that comes with a Backstage instance containing the documentation:
[How to set up a local IDP on a kind cluster](./docs/user-documentation/edpbuilder.md)

### Doc in the repository
  
If you prefer direct access, the content of our documentation is centrally defined and maintained within the [docs folder of this repository](./docs/).

### Doc in a Backstage simulation

The Backstage TechDocs embedding can also be [emulated in a Backstage portal frame running on your computer](./live-preview-integration/README-backstage-local.md). 

## User Documentation

### 📋 Outline
- [What is it? (short description what the software does, max 3 sentences)](#what-is-it)
  - A couple of use cases (different scopes)
  - Why do I need / want this? When should I pass?
  - Compare with other platforms
  - Compare with well-known tools (what parts of my stack / pipeline does this cover?)
    - argo -> vercel
    - monitoring -> data dog
    - forgejo -> graphite
- [Main features (brief list of main features and enablers - why it is in the stack)](#main-features)
  - what are our opinions / core principles and believes that are backed in?
    - k8s > *
  - Developer Portal: Backstage
- [Quick start guide](#quick-start-guide)
- [Configuration](#configuration)
  - structure of the poc (where / how can I change something?)
  - how does it work? (bootstrapping++)
- [Known Issues / TODOs](#known-issues)
- [References (documentation links etc...)](#references)

### 🧐 What is it?

10:40 THU

### 📦 Main features

### ⏱️ Quick start guide

### ⚙️ Configuration

### 🔗 References

## Technical Documentation  
